
local function ggf(String, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	return getglobal(string.format(String, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9))
end







OZ_Initialised = nil
OZ_UpdateTimer = 0
OZ_UpdatePause = 0.2
local roster = 0

function OzRaid_OnUpdate()
	local i
	if(OZ_Initialised) then
		local _CurrentTime = GetTime()
		if (_CurrentTime >= OZ_UpdateTimer) then
			OZ_UpdateTimer = (_CurrentTime + OZ_UpdatePause)

			if(OzRaidOptions:IsVisible())then
				OZ_OptionsSetConfigFromOptions()
			end

			roster = roster + 1
			if(roster > 15)then
				roster = 0
				OZ_UpdateRoster()
				if(OZ_Config[1].hideparty)then
					HidePartyFrame()
				else
					ShowPartyFrame()
				end
			end

 		end

		-- Now update windows
		for i=1,OZ_NWINDOWS do
			OzRaid_Update(i)
		end
	end
end

function OzRaid_Update(n)
	local _CurrentTime = GetTime()
	if(OZ_Config[n].active)then
		if(not OZ_Windows[n].frame.moving)then
			if(OZ_Windows[n].frame.tNext < _CurrentTime)then
				OZ_ProcessBars(n)
				OZ_SetBars(n)
				OZ_CheckVisibility(n)
				OZ_Windows[n].frame.tNext = _CurrentTime + OZ_Config[n].refresh
			end
		end
	end
end

-- This function ensure health/mana is updated as frequently as the fastest window
-- but no faster than 5 times a second
local LastUnitUpdate = 0
function OzRaid_UpdateUnitData()
	local _CurrentTime = GetTime()
	local i
	if( _CurrentTime > LastUnitUpdate + 0.2)then
--DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."Updating Units");
		for i=1,OZ_RaidRoster.nMembers do
			OZ_SetExtraMemberData(i)
		end
		LastUnitUpdate = _CurrentTime
	end
end

local LastTargetUpdate = 0
function OzRaid_UpdateTargetData()
	local _CurrentTime = GetTime()
	local i
	if( _CurrentTime > LastTargetUpdate + 0.2)then
--DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."Updating Targets");
		OZ_UpdateTargets()
		LastTargetUpdate = _CurrentTime
	end
end

function OzRaidFormEvent(arg1)
	if(event == "RAID_ROSTER_UPDATE")then
		OZ_UpdateRoster()
    elseif(event == "VARIABLES_LOADED") then
		OzRaidLoadSavedVariables(OzRaid_Frame1);
    end

end


function OzRaid_OnEvent(event)
end

function OZ_Button_OnLeave()
-- TODO: clear tooltip
end

function OZ_Button_OnEnter(name)
-- TODO: Set tooltip
end

function OZ_Button_Close(frame)
	local id = frame:GetParent():GetParent():GetID()
	OZ_Config[id].active = nil
	OZ_Windows[id].frame:Hide()
	if(id == OZ_OptionsCurrentWindow)then
		OZ_OptionsSetOptionsFromConfig(id)
	end
end

function OZ_Button_Options(frame)
	-- Need to get the frame name...
	local id = frame:GetParent():GetParent():GetID()
	OZ_OptionsSetOptionsFromConfig(id)
	OzRaidOptions:Show()
end

function OZ_Button_BuffClick(frame)
-- TODO: Handle the click
end


function DumpHierarchy(src, q, depth)
--DEFAULT_CHAT_FRAME:AddMessage("Dumping Depth "..q);
--	if (src and (q>0) and src:IsShown()) then
	local i
	if (src and (q>0)) then
		local a="";
		if(depth) then
			for i=0,depth do
				a = a.."   "
			end
		else
			depth = 0
		end
		if (src:GetName()) then
			a = a..src:GetName();
		end
		if (src:GetObjectType()) then
			local x,y,w,h;
			x = src:GetLeft();
			if (not x) then
				x=0;
			end
			y = src:GetTop();
			if (not y) then
				y=0;
			end
			w = src:GetWidth();
			if (not y) then
				y=0;
			end
			h = src:GetHeight();
			if (not y) then
				y=0;
			end

			a = a..format(":  x=%.2f, y=%.2f, w=%.2f, h=%.2f",x,y,w,h);
		end

		DEFAULT_CHAT_FRAME:AddMessage(a);

		if (src:IsObjectType("Frame")) then
			local kids = { src:GetChildren() };
			for _,child in ipairs(kids) do
				DumpHierarchy(child, q-1, depth+1);
			end
			local kids2 = { src:GetRegions() };
			for _,child in ipairs(kids2) do
				DumpHierarchy(child, q-1, depth+1);
			end
		end

	end
end

function OZ_Button_BarClick(frame)
	DEFAULT_CHAT_FRAME:AddMessage("Bar pressed: "..frame:GetName());

end

function OZ_ToggleWindow( n )
	local window = "OzRaid_Frame"..n
	local wObj = getglobal(window)
	if(wObj)then
		if(OZ_Config[wObj:GetID()].active)then
			wObj:Hide()
			OZ_Config[wObj:GetID()].active = nil
		else
			wObj:Show()
			OZ_Config[wObj:GetID()].active = 1
		end
	end
end

function OZ_ClickBar(unit,button)
	if(unit)then
		-- 'JustClick' 
		if( JC_CatchKeyBinding ) then
			if ( JC_CatchKeyBinding(button, unit) ) then
				return;
			end
		end
		-- 'ClickHeal'
		if( CH_UnitClicked )then
			if ( CH_UnitClicked(button, unit) ) then
				return;
			end
		end

		if ( SpellIsTargeting() ) then
			if ( button == "LeftButton" ) then
				SpellTargetUnit(unit);
			elseif ( button == "RightButton" ) then
				SpellStopTargeting();
			end
			return;
		end

		if ( CursorHasItem() ) then
			if ( button == "LeftButton" ) then
				if ( UnitIsUnit(unit, "player") ) then
					AutoEquipCursorItem();
				else
					DropItemOnUnit(unit);
				end
			else
				PutItemInBackpack();
			end
			return;
		end

		TargetUnit(unit);
	end
end

SLASH_OZRAID1 = "/ozraid";
SLASH_OZRAID2 = "/oz"; -- A shortcut or alias
SlashCmdList["OZRAID"] = OZ_ToggleWindow;
